//-----------------------------------------
// LScript Modeler template
//
//Copyright Mike Green
// dodgy@shortbutpurple.fsnet.co.uk
//


@version 2.2
@warnings
@script modeler
myversion=1.0;

mymaps;
// global values go here
myitems;

main
{
//debug();
    mymaps=getmaps();
    if(!mymaps)
    {
		error("No weight maps found");
    	return;
    }
    // requester code goes here

    reqbegin("MG Invert Maps");

    l0 = ctllistbox("Vmaps",200,300,"countitems","nameitem","selectitems");
    c0 = ctlchoice("Invert around",2,@"0%","50%"@);
    c1 = ctlcheckbox("Invert points with no value",true);
    return if !reqpost();

    // get requester control values here
    mychoice=getvalue(c0);
    myinvert=getvalue(c1);

    reqend();

    if(!myitems)
        error("No weight maps selected");

    mypivot=mychoice - 1;
    // processing code goes here
    editbegin();
        if(myinvert)
        {
            foreach(p,points)
            {
                for(i=1;i<=myitems.size();i++)
                {
                    mymap=mymaps[myitems[i]];
                    if(mymap.isMapped(p))
                    {
                        myvalue=mymap.getValue(p);
                        mymap.setValue(p,mypivot-myvalue[1]);
                    }
                    else
                    {
                        mymap.setValue(p,mypivot);
                    }
                }
            }
        }
        else
        {
            foreach(p,points)
            {
                for(i=1;i<=myitems.size();i++)
                {
                    mymap=mymaps[myitems[i]];
                    if(mymap.isMapped(p))
                    {
                        myvalue=mymap.getValue(p);
                        mymap.setValue(p,mypivot-myvalue[1]);
                    }
                }
            }
        }
    editend();

}

countitems
{
    return(mymaps.size());
}

nameitem:index
{
    return(mymaps[index].name);
}

selectitems:items
{
    myitems=items;
}

getmaps
{
    tempmaps=nil;
    mymap=VMap(VMWEIGHT);
    i=1;
    while(mymap)
    {
        if(mymap.type==VMWEIGHT)
        {
            tempmaps[i]=mymap;
            i++;
        }
        mymap=mymap.next();
    }
    return(tempmaps);
}
